@echo off

:: Build pxl to exe

set BASEDIR=%~dp0\
set NASM=%BASEDIR%nasm.exe
set LD=%BASEDIR%ld.exe
set PXC=%BASEDIR%pxc.exe
set LIB_PATH=%BASEDIR%
set LINK_ARGS=-nostdlib -e_main -s "%LIB_PATH%libkernel32.a"

if not exist %1.pxl (
	echo File %1.pxl doesn't exist
	exit /B 1
)

if exist %1.exe del %1.exe
if exist %1.obj del %1.obj
if exist %1.asm del %1.asm

%PXC% %1.pxl > %1.asm
%NASM% -fwin32 -p pexl_rtl.asm -o %1.obj %1.asm && %LD% %1.obj %LINK_ARGS% -o %1.exe && del %1.obj && %1
set BUILDRES=%ERRORLEVEL%
echo Return: %BUILDRES%

if not exist %1.expect goto noexpect
	set /P EXPECTED=< "%1.expect"
	if "%EXPECTED%" == "%BUILDRES%" (
		echo Test passed
	) else (
		echo Test FAILED
	)
:noexpect